



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>十六、JAVA基础（堆和栈）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">十六、JAVA基础（堆和栈）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 17:03:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>一、堆和栈</h1>
<p>堆和栈都是JAVA中的存储结构，也就是说，都是内存中存放数据的地方。</p>
<h3>1、堆：（存放由new创建的对象和数组）</h3>
<p>引用类型的变量，内存分配一般在堆上或者常量池（字符串常量，基本数据类型常量），需要通过new等方式来创建。</p>
<p>首先堆内存主要作用是存放运行时new的对象和数组，存取速度慢，可以运行时动态分配内存。</p>
<h3>2、栈：（基本数据类型变量，对象的引用变量）</h3>
<p>基本数据类型变量（int，short，long，byte，float，double，boolean，char）以及对象的引用变量，内存分配在栈上。变量出了作用域就会自动释放。</p>
<p>由于栈是后进先出模式的。主要用于执行程序，存取速度快，大小生存期必须确定，也就是有作用域，缺乏灵活性。</p>
<div>
<pre class="prettyprint linenums">public class Apple{<br />
    private int id;<br />
    private float price;<br />
    private String name;<br />
    public Apple(int id,float price,String name){<br />
        this.id=id;<br />
        this.price=price;<br />
        this.name=name;<br />
    }

    public static void main(String[] args){<br />
        int a=0;//i基本数据类型变量，在栈里面存放<br />
        Apple app=new Apple(1,10,"红富士")//app是对象的引用变量，存放在栈里面，<br />
        //Apple(1,10,"红富士")是实际的对象，存放在堆里面<br />
    }<br />
}</pre>
</div>
<h3>3、JVM</h3>
<p>JVM是基于堆栈的虚拟机，每个JAVA程序在一个独立的JVM实例上运行，每个JVM实例对应一个堆，同一个JAVA程序内的多线程运行在同个JVM实例上，多个线程之间通过共享堆内存来实现同步。</p>
<h3>4、堆内存和栈内存的区别</h3>
<p>　　当一个方法执行的时候，每个方法都会建立自己的栈内存，在这个方法中定义的变量将会放到这个栈内存中，随着方法的结束，这个方法的栈内存也会被自动销毁，不需要进行GC（垃圾）回收。总而言之就是，所有在方法中定义的局部变量存放在栈内存中。</p>
<p>　　当为程序创建一个对象的时候，这个对象会被保存到运行时候的数据区中，方便反复利用（因为创建对象的成本比较大），这个运行时候的数据区就是堆内存中。堆内存中的对象不会随着方法的结束而自动销毁，有可能方法结束后，这个对象还可能被另外一个引用变量所引用。只有当一个对象没有任何引用变量去引用它的时候，系统的垃圾回收GC才会启动进行销毁。</p>
<h3>5、创建对象的开销成本比较大</h3>
<p>　　因为创建对象的根本路径就是构造方法，通过new关键字来调用一个类中的构造方法才能创建这个类的实例。但是对象并不是完全由构造方法来创建的，当程序调用构造方法的时候，系统会给这个对象分配内存空间，然后进行对象初始化。也就是说，系统创建对象是在构造方法执行之前就完成的，只是此时这个对象还不能被外部程序访问，只能在构造方法中通过this来引用。当构造方法执行结束后，这个对象作为构造方法的返回值被返回，然后把它赋给一个引用类型的变量，让外部程序可以访问。</p>
<h3>6、JAVA比较占内存的原因</h3>
<p>数组和对象在没有引用变量指向的时候，才变成垃圾，不能被使用，但是它依然占着内存，随后在一个不确定的时候才会被垃圾回收GC器给释放掉。</p>
<p>也可以这么理解，实际上存放在栈内存里面的引用变量，指向堆内存中的对象，这就是JAVA的指针。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql5gjx8.html">js键盘事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw2zn3q.html">ECSHOP后台SQL查询提示错误 this sql May contain UPDATE&comma;DELETE&comma;TRUNCATE&comma;ALTER&comma;DROP&comma;FLUSH&comma;INSERT</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1orrk9.html">数理方程：Laplace变换 &amp;amp&semi; 留数（更新中）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e135nj9.html">Linux 命令 - mkdir&colon; 创建目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2opg8.html">&lbrack;github项目&rsqb;基于百度地图二次开发实现的车辆监管（包含车辆定位、车辆图片和方向控制，电子围栏，图形绘制等功能）前端实现&lpar;不包含后端实现&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk4lxe8.html">WARNING&colon; Re-reading the partition table failed with error 16&colon; Device or resource busy&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p27w48.html">【R语言系列】作图入门示例一</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjmd1z8.html">python发送post请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojmomlq.html">DBUtils - Python数据库连接池</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506ej68.html">Windows7下PHP5&period;6&period;19&plus;Apache2&period;4&period;18&plus;MySql5&period;7环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdnwjd9.html">C语言编译数组中有的加code有的不加，有什么区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j107y09.html">ThinkPad T460进不去系统的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ll62q.html">eslint相关工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rpon68.html">Nmap扫描基础常用命令&lpar;包含进阶使用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2pol2q.html">为表格动态添加一行，miniui组件无效</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252rkvq.html">关于Unity中物体分别在本地和世界坐标系对应方向的移动</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r7y328.html">delphi7产生条码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zydmm19.html">andorid       列表视图  ListView  之BaseAdapter</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn576mq.html">servlet 让浏览器输出中文&comma;并成功打印出来&period;2种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/902y3roq.html">hive多表联合查询&lpar;GroupLens-&amp;gt&semi;Users&comma;Movies&comma;Ratings表&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxd3n5z9.html">windows 如何不显示带点的文件名、文件夹？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o16kmeq.html">20165306学习基础和C语言基础调查</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o5e0e8.html">《EM-PLANT仿真技术教程》读书笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj7p049.html">python 协程 demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r3d2o9.html">vs2015 VS-Visual Studio-IIS Express 支持局域网访问</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25zx3lq.html">javaSE习题 第二章 基本数据类型和数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25zxoxq.html">分组查询以及having使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd3omj9.html">Java代码优化，都有哪些常用方法？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jonynq.html">A NEW HYPERSPECTRAL BAND SELECTION APPROACH BASED ON CONVOLUTIONAL NEURAL NETWORK文章笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj7dd79.html">Spark SQL笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
